/*
 *
 *  D-Bus++ - C++ bindings for D-Bus
 *
 *  Copyright (C) 2005-2009  Paolo Durante <shackan@gmail.com>
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <cctype>
#include <cstdlib>
#include <cstring>
#include <string>
#include <map>
#include <iostream>
#include <fstream>
#include <sstream>
#include <algorithm>

#include "xml.h"

using namespace std;
using namespace DBus;

static const char *header =
"\n/*"
"\n *	This file was automatically generated by dbusxx-xml2cpp; DO NOT EDIT!"
"\n */"
"\n"
"\n";

static const char *dbus_includes =
"\n#include <dbus-c++/dbus.h>"
"\n#include <memory>"
"\n";

typedef map<string,string> TypeCache;

void usage(const char *argv0)
{
	cerr << endl << "Usage: " << argv0 << " <xmlfile> [ --proxy=<outfile.h> ] [ --adaptor=<outfile.h> ]"
	     << endl;
	exit(-1);
}

void split_file(const string& filename, string& base, string& ext)
{
	base.clear();
	ext.clear();
	size_t found = filename.find_last_of(".");
	base = filename.substr(0, found);
	if ( found != string::npos )
	{
		ext = filename.substr(found+1);
	}
}

void underscorize(string &str)
{
	for (unsigned int i = 0; i < str.length(); ++i)
	{
		if (!isalpha(str[i]) && !isdigit(str[i])) str[i] = '_';
	}
}

int char_to_atomic_type(char t)
{
	if (strchr("ybnqiuxtdsgavre", t))
		return t;

	return 0;
}

const char *atomic_type_to_string(char t)
{
	static struct { char type; const char *name; } atos[] =
	{
		{ 'y', "uint8_t" },
		{ 'b', "bool" },
		{ 'n', "int16_t" },
		{ 'q', "uint16_t" },
		{ 'i', "int32_t" },
		{ 'u', "uint32_t" },
		{ 'x', "int64_t" },
		{ 't', "uint64_t" },
		{ 'd', "double" },
		{ 's', "std::string" },
		{ 'o', "::DBus::Path" },
		{ 'g', "::DBus::Signature" },
		{ 'v', "::DBus::Variant" },
		{ '\0', "" }
	};
	int i;

	for (i = 0; atos[i].type; ++i)
	{
		if (atos[i].type == t) break;
	}
	return atos[i].name;
}

bool is_atomic_type(const string &type)
{
	return type.length() == 1 && char_to_atomic_type(type[0]) != 0;
}

void parse_signature(const string &signature, string &type, unsigned int &i)
{
	for (; i < signature.length(); ++i)
	{
		switch (signature[i])
		{
			case 'a':
			{
				switch (signature[++i])
				{
					case '{':
					{
						type += "std::map< ";

						const char *atom = atomic_type_to_string(signature[++i]);
						if (!atom)
						{
							cerr << "invalid signature" << endl;
							exit(-1);
						}
						type += atom;
						type += ", ";
						++i;

 						parse_signature(signature, type, i);
 						type += " >";					

 						break;
 					}
 					case '(':
 					{
 						type += "std::vector< ::DBus::Struct< ";

 						parse_signature(signature, type, ++i);

 						if (signature[i] !=  ')')
 						{
 							cerr << "invalid signature \"" << signature << "\"" << endl;
 							exit(-1);
 						}

 						type += " > >";

 						if((i+1) < signature.length() &&
 				   			signature[i+1] !=  ')' && signature[i+1] !=  '}')
 						{
 							type += ", ";
 						}
						break;
					}
					default:
					{
						type += "std::vector< ";
 						const char* atom = atomic_type_to_string(signature[i]);
 						if(!atom)
 						{
 							cerr << "invalid signature \"" << signature << "\"" << endl;
 							exit(-1);
 						}
 						type += atom;

 						type += " >";

 						if((i+1) < signature.length() &&
 				   			signature[i+1] !=  ')' && signature[i+1] !=  '}')
 						{
 							type += ", ";
 						}
						break;
					}
				}
				break;
			}
			case '(':
			{
				type += "::DBus::Struct< ";
				++i;
				parse_signature(signature, type, i);
				type += " >";
				if((i+1) < signature.length() &&
		   			signature[i+1] !=  ')' && signature[i+1] !=  '}')
				{
					type += ", ";
				}
				continue;
			}
			case ')':
			case '}':
			{
				return;
			}
			default:
			{
				const char *atom = atomic_type_to_string(signature[i]);
				if (!atom)
				{
					cerr << "invalid signature" << endl;
					exit(-1);
				}
				type += atom;

				if (signature[i+1] != ')' && signature[i+1] != '}' && i+1 < signature.length())
				{
					type += ", ";
				}
				break;
			}
		}
	}
}

string signature_to_type(const string &signature)
{
	string type;
	unsigned int i = 0;
	parse_signature(signature, type, i);
	return type;
}

void generate_proxy(Xml::Document &doc, const char *filename)
{
	cerr << "writing " << filename << endl;

	ofstream file(filename);
	if (file.bad())
	{
		cerr << "unable to write file " << filename << endl;
		exit(-1);
	}

	file << header;
	string filestring;
	string file_ext;
	split_file(filename, filestring, file_ext);
	underscorize(filestring);
	transform(filestring.begin(), filestring.end(), filestring.begin(), ::toupper);
	transform(file_ext.begin(), file_ext.end(), file_ext.begin(), ::toupper);

	string cond_comp = "DBUSXXX_" + filestring + "_PROXY_MARSHAL_" + file_ext;

	file << "#ifndef " << cond_comp << endl;
	file << "#define " << cond_comp << endl;

	file << dbus_includes;

	Xml::Node &root = *(doc.root);
	Xml::Nodes interfaces = root["interface"];

	for (Xml::Nodes::iterator ifi = interfaces.begin(); ifi != interfaces.end(); ++ifi)
	{
		Xml::Node &iface = **ifi;
		Xml::Nodes anns = iface["annotation"];
		Xml::Nodes methods = iface["method"];
		Xml::Nodes signals = iface["signal"];
		Xml::Nodes properties = iface["property"];
		Xml::Nodes ms;
		ms.insert(ms.end(), methods.begin(), methods.end());
		ms.insert(ms.end(), signals.begin(), signals.end());

		unsigned int i = 0;

		bool iface_ann_extra = false;

		for (Xml::Nodes::iterator ni = anns.begin(); ni != anns.end(); ++ni)
		{
			Xml::Node &ann = **ni;
			if (ann.get("name") == "org.freedesktop.DBus.Cxx.ExtraInfo")
				if (ann.get("value") == "proxy" || ann.get("value") == "both")
				iface_ann_extra = true;
		}

		string iface_name = iface.get("name");
		if (iface_name == "org.freedesktop.DBus.Introspectable"
		 || iface_name == "org.freedesktop.DBus.Properties")
		{
			cerr << "skipping interface " << iface_name << endl;
			continue;
		}

		istringstream ss(iface_name);
		string nspace;
		unsigned int nspaces = 0;

		file << endl;

		while (ss.str().find('.', ss.tellg()) != string::npos)
		{
			getline(ss, nspace, '.');

			file << "namespace " << nspace << " {" << endl;

			++nspaces;
		}

		string iface_class;

		getline(ss, iface_class);

		iface_class += "_proxy";

		cerr << "generating code for interface " << iface_name << "..." << endl;

		file
		<< endl << "class " << iface_class
		<< endl << " : virtual public ::DBus::CallbackTarget, public ::DBus::InterfaceProxy"
		<< endl << "{"
		<< endl << "public:"
		<< endl
		<< endl << "	" << iface_class << "()"
      << endl << "   : ::DBus::CallbackTarget()"
		<< endl << "	, ::DBus::InterfaceProxy(\"" << iface_name << "\") {"
		<< endl;

		for (Xml::Nodes::iterator si = signals.begin(); si != signals.end(); ++si)
		{
			Xml::Node &signal = **si;

			string marshname = "_" + signal.get("name") + "_stub";

			file << "		connect_signal("
			     << iface_class << ", " << signal.get("name") << ", "
				 << "_" << signal.get("name") << "_stub);" << endl;
		}

		file << "	}" << endl;

		file
		<< endl << "	// Context of the response to a received pending call"
		<< endl << "	class CallContext : public ::DBus::CallInfo"
		<< endl << "	{"
		<< endl << "	public:"
		<< endl
		<< endl << "		" << iface_class << " &iface;"
		<< endl << "		void *data;"
		<< endl
		<< endl << "		CallContext(" << iface_class << " &ifc, ::DBus::PendingCall &call, void *ptr)"
		<< endl << "		: ::DBus::CallInfo(ifc.object().conn(), call), iface(ifc), data(ptr) {}"
		<< endl
		<< endl << "	private:"
		<< endl
		<< endl << "		// Not implemented to prevent copy-construction"
		<< endl << "		CallContext(const CallContext &);"
		<< endl << "	};"
		<< endl;

		for (Xml::Nodes::iterator pi = properties.begin ();
		     pi != properties.end (); ++pi)
		{
			Xml::Node & property = **pi;
			string prop_name = property.get ("name");
			string property_access = property.get ("access");
			if (property_access == "read" || property_access == "readwrite")
			{
				file
				<< endl << "public:"
				<< endl << "	// DBus property: getter method"
				<< endl << "	const " << signature_to_type(property.get("type")) << " " << prop_name << "() {"
				<< endl << "		::DBus::CallMessage call;"
				<< endl << "		call.member(\"Get\"); call.interface(\"org.freedesktop.DBus.Properties\");"
				<< endl << "		::DBus::MessageIter wi = call.writer(); "
				<< endl << "		const std::string interface_name = \"" << iface_name << "\";"
				<< endl << "		const std::string property_name  = \"" << prop_name << "\";"
				<< endl << "		wi << interface_name;"
				<< endl << "		wi << property_name;"
				<< endl << "		::DBus::Message ret = this->invoke_method(call);"
				<< endl << "		::DBus::MessageIter ri = ret.reader();"
				<< endl << "		::DBus::Variant argout; "
				<< endl << "		ri >> argout;"
				<< endl << "		return argout;"
				<< endl << "	};"
				<< endl;
			}

			if (property_access == "write" || property_access == "readwrite")
			{
				file
				<< endl << "public:"
				<< endl << "	// DBus property: setter method"
				<< endl << "	void " << prop_name << "( const "<< signature_to_type(property.get("type")) << " &input" << ") {"
				<< endl << "		::DBus::CallMessage call;"
				<< endl << "		call.member(\"Set\"); call.interface(\"org.freedesktop.DBus.Properties\");"
				<< endl << "		::DBus::MessageIter wi = call.writer();"
				<< endl << "		::DBus::Variant value;"
				<< endl << "		::DBus::MessageIter vi = value.writer();"
				<< endl << "		vi << input;"
				<< endl << "		const std::string interface_name = \"" << iface_name << "\";"
				<< endl << "		const std::string property_name  = \"" << prop_name << "\";"
				<< endl << "		wi << interface_name;"
				<< endl << "		wi << property_name;"
				<< endl << "		wi << value;"
				<< endl << "		::DBus::Message ret = this->invoke_method(call);"
				<< endl << "	};"
				<< endl;
            }
		}

		for (Xml::Nodes::iterator mi = methods.begin(); mi != methods.end(); ++mi)
		{
			Xml::Node &method = **mi;
			Xml::Nodes anns = method["annotation"];
			Xml::Nodes args = method["arg"];
			Xml::Nodes args_in = args.select("direction","in");
			Xml::Nodes args_out = args.select("direction","out");

			string method_name = method.get("name");

			bool ann_extra = iface_ann_extra;

			for (Xml::Nodes::iterator ni = anns.begin(); ni != anns.end(); ++ni)
			{
				Xml::Node &ann = **ni;
				string ann_name = ann.get("name");
				string ann_value = ann.get("value");

				if (ann_name == "org.freedesktop.DBus.Cxx.ExtraInfo")
					if (ann_value == "proxy" || ann_value == "both")
						ann_extra = true;

				cerr << "method \"" << method_name << "\" annotated with \"" << ann_name << "\"" << endl;
			}

			file
			<< endl << "private:"
			<< endl
			<< endl << "	// Class member function binding for \"" << method_name << "\""
			<< endl << "	template < class Delegate >"
			<< endl << "	struct _" << method_name << "_memBind {"
			<< endl << "		typedef void (Delegate::*Method)("
			<< endl;

			i = 0;
			for (Xml::Nodes::iterator ai = args_out.begin(); ai != args_out.end(); ++ai, ++i)
			{
				Xml::Node &arg = **ai;
				file << "			const " << signature_to_type(arg.get("type")) << " &, " << endl;
			}

			file    << "			CallContext&);"
			<< endl
			<< endl << "		Delegate* delegate;"
			<< endl << "		Method method;"
			<< endl << "		void* data;"
			<< endl << "		_" << method_name << "_memBind(Delegate* del, Method meth, void* ptr)"
			<< endl << "		: delegate(del), method(meth), data(ptr) {}"
			<< endl << "	};"
			<< endl;

			file
			<< endl
			<< endl << "	// Stub for \"" << method_name << "\" member function callback"
			<< endl << "	template < class Delegate >"
			<< endl << "	void _" << method_name << "_memStub(::DBus::PendingCall &call) {"
			<< endl << "		_" << method_name << "_memBind<Delegate>* bind = static_cast<_" << method_name << "_memBind<Delegate>*>(call.data());"
			<< endl << "		CallContext ret(*this, call, bind->data);";

			i = 0;
			for (Xml::Nodes::iterator ao = args_out.begin(); ao != args_out.end(); ++ao, ++i)
			{
				Xml::Node &arg = **ao;
				file << endl << "		" << signature_to_type(arg.get("type")) << " "
					 << "argout" << i << ";";
			}

			file
			<< endl << "		if (!ret.error()) {"
			<< endl << "			::DBus::MessageIter ri = ret.msg().reader();";

			i = 0;
			for (Xml::Nodes::iterator ao = args_out.begin(); ao != args_out.end(); ++ao, ++i)
			{
				file << endl << "			ri >> " << "argout" << i << ";";
			}

			file
			<< endl	<< "		}"
			<< endl << "		(bind->delegate->*bind->method)(";
			i = 0;
			for (Xml::Nodes::iterator ao = args_out.begin(); ao != args_out.end(); ++ao, ++i)
			{
					 file << "argout" << i << ", ";
			}
			file    << "ret);"
			<< endl << "		delete bind;"
			<< endl << "	}"
			<< endl;

			file
			<< endl << "public:"
			<< endl
			<< endl << "	// \"" << method_name << "\" asynchronous call with member function callback"
			<< endl << "	template < class Delegate >"
			<< endl << "	::DBus::PendingCall " << method_name << "_async("
			<< endl;

			i = 0;
			for (Xml::Nodes::iterator ai = args_in.begin(); ai != args_in.end(); ++ai, ++i)
			{
				Xml::Node &arg = **ai;
				file << "		const " << signature_to_type(arg.get("type")) << "& ";

				file << "argin" << i << "," << endl;
			}

			file <<    "		Delegate* delegate,"
			<< endl << "		typename _" << method_name << "_memBind<Delegate>::Method method,"
			<< endl << "		void* data,"
			<< endl << "		int timeout = -1) {"
			<< endl << "		::DBus::CallMessage call;"
			<< endl << "		::DBus::MessageIter wi = call.writer();"
			<< endl;

			i = 0;
			for (Xml::Nodes::iterator ai = args_in.begin(); ai != args_in.end(); ++ai, ++i)
			{
				file << "		wi << " << "argin" << i << ";" << endl;
			}

			file <<    "		call.member(\"" << method.get("name") << "\");"
			<< endl << "		::DBus::PendingCallSlot slot;"
			<< endl << "		slot = new ::DBus::CallbackNoReturn<" << iface_class << ", ::DBus::PendingCall &>("
			<< endl << "			this, &" << iface_class << "::_" << method_name << "_memStub<Delegate>);"
			<< endl << "      std::auto_ptr<_" << method_name << "_memBind<Delegate> > binding(new _" << method_name << "_memBind<Delegate>(delegate, method, data));"
			<< endl << "		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);"
			<< endl << "      binding.release();"
			<< endl << "		return async;"
			<< endl << "	}"
			<< endl;

			if (args_out.size() == 0 || args_out.size() > 1)
			{
				file << endl << "	void ";
			}
			else if (args_out.size() == 1)
			{
				file << endl << "	" << signature_to_type(args_out.front()->get("type")) << " ";
			}

			file << method_name << "(";

			i = 0;
			for (Xml::Nodes::iterator ai = args_in.begin(); ai != args_in.end(); ++ai, ++i)
			{
				Xml::Node &arg = **ai;
				file << "const " << signature_to_type(arg.get("type")) << "& " << "argin" << i << ", ";
			}

			if (args_out.size() > 1)
			{
				i = 0;
				for (Xml::Nodes::iterator ao = args_out.begin(); ao != args_out.end(); ++ao, ++i)
				{
					Xml::Node &arg = **ao;
					file << signature_to_type(arg.get("type")) << "& " << "argout" << i << ", ";
				}
			}

			if (ann_extra)
			{
				file << "::DBus::CallInfo &info, ";
			}

			file <<    "int timeout = -1) {"
			<< endl << "		::DBus::CallMessage call;"
			<< endl;

			if (args_in.size() > 0)
			{
				file << "		::DBus::MessageIter wi = call.writer();" << endl;
			}

			i = 0;
			for (Xml::Nodes::iterator ai = args_in.begin(); ai != args_in.end(); ++ai, ++i)
			{
				file << "		wi << argin" << i << ";" << endl;
			}

			file <<    "		call.member(\"" << method_name << "\");"
			<< endl << "		::DBus::Message ret = invoke_method(call, timeout);"
			<< endl;

			if (ann_extra)
			{
				file << "		info = ::DBus::CallInfo(object().conn(), ret);" << endl; 
			}

			if (args_out.size() > 0)
			{
				file << "		::DBus::MessageIter ri = ret.reader();" << endl;
			}

			if (args_out.size() == 1)
			{
				file <<    "		" << signature_to_type(args_out.front()->get("type")) << " argout;"
				<< endl << "		ri >> argout;"
				<< endl << "		return argout;"
				<< endl;
			}
			else if (args_out.size() > 1)
			{
				i = 0;
				for (Xml::Nodes::iterator ao = args_out.begin(); ao != args_out.end(); ++ao, ++i)
				{
					file << "		ri >> argout" << i << ";" << endl;
				}
			}
			file << "	}" << endl;
		}

		for (Xml::Nodes::iterator si = signals.begin(); si != signals.end(); ++si)
		{
			Xml::Node &signal = **si;
			Xml::Nodes args = signal["arg"];
			std::string name = signal.get("name");

			file
			<< endl << "private:"
			<< endl << "	// DBus signal: reimplement this method to receive the \"" << name << "\" signal"
			<< endl << "	virtual void " << name << "(";

			i = 0;
			for (Xml::Nodes::iterator ai = args.begin(); ai != args.end(); ++ai, ++i)
			{
				Xml::Node &arg = **ai;
				std::string name = arg.get("name");

				if (ai != args.begin())
					file << ", ";

				file << "const " << signature_to_type(arg.get("type")) << " &";

				if (name.length())
					file << name;
			}
			file << ") {}" << endl;
		}

		for (Xml::Nodes::iterator si = signals.begin(); si != signals.end(); ++si)
		{
			Xml::Node &signal = **si;
			Xml::Nodes args = signal["arg"];

			file
			<< endl << "private:"
			<< endl << "	void _" << signal.get("name") << "_stub(const ::DBus::SignalMessage &sig) {" << endl;

			if (args.size() > 0)
			{
				file << "		::DBus::MessageIter ri = sig.reader();" << endl;
			}

			i = 0;
			for (Xml::Nodes::iterator ai = args.begin(); ai != args.end(); ++ai, ++i)
			{
				Xml::Node &arg = **ai;
				file << "		" << signature_to_type(arg.get("type"))
				     << " arg" << i << ";" << " ri >> " << "arg" << i << ";" << endl;
			}

			file << "		" << signal.get("name") << "(";

			i = 0;
			for (Xml::Nodes::iterator ai = args.begin(); ai != args.end(); ++ai, ++i)
			{
				file << "arg" << i;

				if (ai+1 != args.end())
					file << ", ";
			}

			file << ");" << endl
			     << "	}" << endl;
		}
		file << "};" << endl;

		file << endl;
		for (i = 0; i < nspaces; ++i)
		{
			file << "} ";
		}
		file << endl;
	}
	file << "#endif//" << cond_comp << endl;

	file.close();
}

void generate_adaptor(Xml::Document &doc, const char *filename)
{
	cerr << "writing " << filename << endl;

	ofstream file(filename);
	if (file.bad())
	{
		cerr << "unable to write file " << filename << endl;
		exit(-1);
	}

	file << header;
	string filestring;
	string file_ext;
	split_file(filename, filestring, file_ext);
	underscorize(filestring);
	transform(filestring.begin(), filestring.end(), filestring.begin(), ::toupper);
	transform(file_ext.begin(), file_ext.end(), file_ext.begin(), ::toupper);

	string cond_comp = "DBUSXX_" + filestring + "_ADAPTOR_MARSHAL_" + file_ext;

	file << "#ifndef " << cond_comp << endl;
	file << "#define " << cond_comp << endl;

	file << dbus_includes;

	Xml::Node &root = *(doc.root);
	Xml::Nodes interfaces = root["interface"];

	for (Xml::Nodes::iterator ifi = interfaces.begin(); ifi != interfaces.end(); ++ifi)
	{
		Xml::Node &iface = **ifi;
		Xml::Nodes anns = iface["annotation"];
		Xml::Nodes methods = iface["method"];
		Xml::Nodes signals = iface["signal"];
		Xml::Nodes properties = iface["property"];
		Xml::Nodes ms;
		ms.insert(ms.end(), methods.begin(), methods.end());
		ms.insert(ms.end(), signals.begin(), signals.end());

		unsigned int i = 0;
		bool iface_ann_extra = false;
		bool iface_ann_async = false;

		for (Xml::Nodes::iterator ni = anns.begin(); ni != anns.end(); ++ni)
		{
			Xml::Node &ann = **ni;

			string ann_name = ann.get("name");
			string ann_value = ann.get("value");

			if (ann_name == "org.freedesktop.DBus.Cxx.Async")
				if (ann_value == "adaptor" || ann_value == "both")
					iface_ann_async = true;

			if (ann_name == "org.freedesktop.DBus.Cxx.ExtraInfo")
				if (ann_value == "adaptor" || ann_value == "both")
					iface_ann_extra = true;
		}

		string iface_name = iface.get("name");
		if (iface_name == "org.freedesktop.DBus.Introspectable"
		 || iface_name == "org.freedesktop.DBus.Properties")
		{
			cerr << "skipping interface " << iface_name << endl;
			continue;
		}

		istringstream ss(iface_name);
		string nspace;
		unsigned int nspaces = 0;

		file << endl;

		while (ss.str().find('.', ss.tellg()) != string::npos)
		{
			getline(ss, nspace, '.');

			file << "namespace " << nspace << " {" << endl;

			++nspaces;
		}

		string iface_class;

		getline(ss, iface_class);

		iface_class += "_adaptor";

		cerr << "generating code for interface " << iface_name << "..." << endl;

		file
		<< endl << "class " << iface_class
		<< endl << ": virtual public ::DBus::CallbackTarget, public ::DBus::InterfaceAdaptor"
		<< endl << "{"
		<< endl << "public:"
		<< endl
		<< endl << "	" << iface_class << "()"
      << endl << "   : ::DBus::CallbackTarget()"
		<< endl << "	, ::DBus::InterfaceAdaptor(\"" << iface_name << "\")"
		<< endl << "	{"
		<< endl;

		for (Xml::Nodes::iterator pi = properties.begin(); pi != properties.end(); ++pi)
		{
			Xml::Node &property = **pi;

			file << "		bind_property("
			     << property.get("name") << ", "
			     << "\"" << property.get("type") << "\", "
			     << (property.get("access").find("read") != string::npos
				? "true"
				: "false")
			     << ", "
			     << (property.get("access").find("write") != string::npos
				? "true"
				: "false")
			     << ");" << endl;
		}

		for (Xml::Nodes::iterator mi = methods.begin(); mi != methods.end(); ++mi)
		{
			Xml::Node &method = **mi;

			Xml::Nodes anns = method["annotation"];
			string method_name = method.get("name");

			bool ann_async = iface_ann_async;
			bool ann_extra = iface_ann_extra;

			for (Xml::Nodes::iterator ni = anns.begin(); ni != anns.end(); ++ni)
			{
				Xml::Node &ann = **ni;
				string ann_name = ann.get("name");
				string ann_value = ann.get("value");

				if (ann_name == "org.freedesktop.DBus.Cxx.Async")
					if (ann_value == "adaptor" || ann_value == "both")
						ann_async = true;

				if (ann_name == "org.freedesktop.DBus.Cxx.ExtraInfo")
					if (ann_value == "adaptor" || ann_value == "both")
						ann_extra = true;
			}

			if (ann_async)
			{
				file << "		register_async(" << iface_class << ", " << method_name
				<< ", _" << method_name << "_stub);" << endl;
			}
			else
			{
				file << "		register_method(" << iface_class << ", " << method_name
				<< ", _" << method_name << "_stub);" << endl;
			}
		}

		file << "	}" << endl;

		file
		<< endl << "	::DBus::IntrospectedInterface *const introspect() const {"
		<< endl;

		for (Xml::Nodes::iterator mi = ms.begin(); mi != ms.end(); ++mi)
		{
			Xml::Node &method = **mi;
			Xml::Nodes args = method["arg"];

			string method_name = method.get("name");

			file
			<< endl << "		static ::DBus::IntrospectedArgument " << method_name << "_args[] = "
			<< endl << "		{"
			<< endl;

			for (Xml::Nodes::iterator ai = args.begin(); ai != args.end(); ++ai)
			{
				Xml::Node &arg = **ai;

				file << "			{ ";

				if (arg.get("name").length())
				{
					file << "\"" << arg.get("name") << "\", ";
				}
				else
				{
					file << "0, ";
				}
				file << "\"" << arg.get("type") << "\", "
				     << (arg.get("direction") == "in" ? "true" : "false")
				     << " }," << endl;
			}
			file <<    "			{ 0, 0, 0 }"
			<< endl << "		};"
			<< endl;
		}

		file
		<< endl << "		static ::DBus::IntrospectedMethod " << iface_class << "_methods[] = "
		<< endl << "		{"
		<< endl;

		for (Xml::Nodes::iterator mi = methods.begin(); mi != methods.end(); ++mi)
		{
			Xml::Node &method = **mi;

			string method_name = method.get("name");

			file << "			{ \"" << method_name << "\", " << method_name << "_args }," << endl;
		}

		file <<    "			{ 0, 0 }"
		<< endl << "		};"
		<< endl;

		file
		<< endl << "		static ::DBus::IntrospectedMethod " << iface_class << "_signals[] = "
		<< endl << "		{"
		<< endl;

		for (Xml::Nodes::iterator si = signals.begin(); si != signals.end(); ++si)
		{
			Xml::Node &method = **si;

			string method_name = method.get("name");

			file << "			{ \"" << method_name << "\", " << method_name << "_args }," << endl;
		}

		file <<    "			{ 0, 0 }"
		<< endl << "		};"
		<< endl;

		file
		<< endl << "		static ::DBus::IntrospectedProperty " << iface_class << "_properties[] = "
		<< endl << "		{"
		<< endl;

		for (Xml::Nodes::iterator pi = properties.begin(); pi != properties.end(); ++pi)
		{
			Xml::Node &property = **pi;

			file << "			{ "
				<< "\"" << property.get("name") << "\", "
				<< "\"" << property.get("type") << "\", "
				<< (property.get("access").find("read") != string::npos
				   ? "true"
				   : "false")
				<< ", "
				<< (property.get("access").find("write") != string::npos
				   ? "true"
				   : "false")
				<< " }," << endl;
		}

		file <<    "			{ 0, 0, 0, 0 }"
		<< endl << "		};"
		<< endl;

		file
		<< endl << "		static ::DBus::IntrospectedInterface " << iface_class << "_interface = "
		<< endl << "		{"
		<< endl << "			\"" << iface_name << "\","
		<< endl << "			" << iface_class << "_methods,"
		<< endl << "			" << iface_class << "_signals,"
		<< endl << "			" << iface_class << "_properties"
		<< endl << "		};"
		<< endl << "		return &" << iface_class << "_interface;"
		<< endl << "	}"
		<< endl;

		for (Xml::Nodes::iterator pi = properties.begin(); pi != properties.end(); ++pi)
		{
			Xml::Node &property = **pi;
			string name = property.get("name");
			string type = property.get("type");
			string type_name = signature_to_type(type);

			file
			<< endl << "public:"
			<< endl << "	// DBus property: set it with " << name << "(value) and read it back with " << name << "()"
			<< endl << "	::DBus::PropertyAdaptor< " << type_name << " > " << name << ";"
			<< endl;
		}

		for (Xml::Nodes::iterator si = signals.begin(); si != signals.end(); ++si)
		{
			Xml::Node &signal = **si;
			Xml::Nodes args = signal["arg"];
			std::string name = signal.get("name");

			file
			<< endl << "public:"
			<< endl << "	// DBus signal: use " << name << "(args) to broadcast this signal"
			<< endl << "	void " << name << "(";

			i = 0;
			for (Xml::Nodes::iterator a = args.begin(); a != args.end(); ++a, ++i)
			{
				Xml::Node &arg = **a;

				file << "const " << signature_to_type(arg.get("type")) << "& arg" << i+1;

				if (i+1 != args.size())
					file << ", ";
			}
			file <<    ") {"
			<< endl << "		::DBus::SignalMessage sig(\"" << signal.get("name") <<"\");"
			<< endl;

			if (args.size() > 0)
			{
				file << "		::DBus::MessageIter wi = sig.writer();" << endl;

				for (unsigned int i = 0; i < args.size(); ++i)
				{
					file << "		wi << arg" << i+1 << ";" << endl;
				}
			}

			file <<    "		emit_signal(sig);"
			<< endl << "	}"
			<< endl;
		}

		// See if there are any annotated methods
		bool async_method_exists = iface_ann_async;
		for (Xml::Nodes::iterator mi = methods.begin();
			!async_method_exists && (mi != methods.end()); ++mi)
		{
			Xml::Node &method = **mi;
			Xml::Nodes anns = method["annotation"];

			string method_name = method.get("name");

			for (Xml::Nodes::iterator ni = anns.begin(); ni != anns.end(); ++ni)
			{
				Xml::Node &ann = **ni;
				string ann_name = ann.get("name");
				string ann_value = ann.get("value");

				if (ann_name == "org.freedesktop.DBus.Cxx.Async")
					if (ann_value == "adaptor" || ann_value == "both")
					{
						async_method_exists = true;
						break;
					}
			}
		}

		// If at least one asynchronous method exists then ...
		if ( async_method_exists )
		{
			file
			<< endl
			<< endl << "   class _BaseContext"
			<< endl << "   {"
			<< endl << "   public:"
			<< endl << "      _BaseContext(" << iface_class << " &ifc, const ::DBus::Message &msg)"
			<< endl << "         : iface(ifc), _msg(msg), _replied(false) {}"
			<< endl << "      virtual ~_BaseContext() {}"
			<< endl
			<< endl << "      bool hasReplied() const { return _replied; }"
			<< endl << "      " << iface_class << " &iface;"
			<< endl      
			<< endl << "      void send_error(const char *name, const char *description) {"
			<< endl << "         if ( !hasReplied() ) {"
			<< endl << "            ::DBus::ErrorMessage msg(_msg, name, description);"
			<< endl << "            iface.object().conn().send(msg);"
			<< endl << "            setReplied(true);"
			<< endl << "         } else {"
			<< endl << "            throw ::DBus::ErrorFailed(ERROR_MSG_MULTIPLE_REPLIES());"
			<< endl << "         }"
			<< endl << "      }"
			<< endl      
			<< endl << "      void send_error(const ::DBus::Error &error) {"
			<< endl << "         if ( !hasReplied() ) {"
			<< endl << "            ::DBus::ErrorMessage msg(_msg, error.name(), error.description());"
			<< endl << "            iface.object().conn().send(msg);"
			<< endl << "            setReplied(true);"
			<< endl << "         } else {"
			<< endl << "            throw ::DBus::ErrorFailed(ERROR_MSG_MULTIPLE_REPLIES());"
			<< endl << "         }"
			<< endl << "      }"
			<< endl      
			<< endl << "   protected:"
			<< endl << "      void setReplied(bool replied) { _replied = replied; }"
			<< endl << "      static const char* ERROR_MSG_MULTIPLE_REPLIES()"
			<< endl << "	        { return \"The application tried to send multiple replies\"; }"
			<< endl << "      static const char* ERROR_MSG_OBJ_DESTROYED_BEFORE_COMPLETING_REQUEST()"
			<< endl << "	        { return \"Object was destroyed before completing the request\"; }"
			<< endl << "	  ::DBus::Message _msg;"
			<< endl   
			<< endl << "   private:"
			<< endl << "      // Unsupported copy constructor"
			<< endl << "      _BaseContext(const _BaseContext&);"
			<< endl
			<< endl << "      bool _replied;"
			<< endl << "   };"
			<< endl;
		}

		for (Xml::Nodes::iterator mi = methods.begin(); mi != methods.end(); ++mi)
		{
			Xml::Node &method = **mi;
			Xml::Nodes anns = method["annotation"];
			Xml::Nodes args = method["arg"];
			Xml::Nodes args_in = args.select("direction","in");
			Xml::Nodes args_out = args.select("direction","out");

			string method_name = method.get("name");

			bool ann_async = iface_ann_async;
			bool ann_extra = iface_ann_extra;

			for (Xml::Nodes::iterator ni = anns.begin(); ni != anns.end(); ++ni)
			{
				Xml::Node &ann = **ni;
				string ann_name = ann.get("name");
				string ann_value = ann.get("value");

				if (ann_name == "org.freedesktop.DBus.Cxx.Async")
					if (ann_value == "adaptor" || ann_value == "both")
						ann_async = true;

				if (ann_name == "org.freedesktop.DBus.Cxx.ExtraInfo")
					if (ann_value == "adaptor" || ann_value == "both")
						ann_extra = true;
			}

			if (ann_async)
			{
				file
				<< endl << "public:"
				<< endl
				<< endl << "	class _" << method_name << "_context : public _BaseContext"
				<< endl << "	{"
				<< endl;
#if 0
				<< endl << "		struct Args {"
				<< endl;
#ifdef SAVE_SERVER_ARGSIN
				i = 0;
				for (Xml::Nodes::iterator ai = args_in.begin(); ai != args_in.end(); ++ai, ++i)
				{
					Xml::Node &arg = **ai;
					file << "			const " << signature_to_type(arg.get("type"));

					string arg_name = arg.get("name");
					if (arg_name.length())
						file << " " << arg_name << ";" << endl;
					else
						file << " argin" << i << ";" << endl;
				}
#endif
				i = 0;
				for (Xml::Nodes::iterator ao = args_out.begin(); ao != args_out.end(); ++ao, ++i)
				{
					Xml::Node &arg = **ao;
					file << "			" << signature_to_type(arg.get("type"));

					string arg_name = arg.get("name");
					if (arg_name.length())
						file << " " << arg_name << ";" << endl;
					else
						file << " argout" << i << ";" << endl;
				}

				file    << "		} args;"
				<< endl
#endif
				file
				<< endl << "	private:"
				<< endl
				<< endl << "		// Unsupported copy-constructor"
				<< endl << "		_" << method_name << "_context(const _" << method_name << "_context &);"
				<< endl
				<< endl << "	public:"
				<< endl
				<< endl << "		_" << method_name << "_context(" << iface_class << " &ifc, const ::DBus::Message &msg)"
				<< endl;

				if ( ann_extra )
				{
					file << "		: _BaseContext(ifc, msg), callInfo(ifc.object().conn(), msg) {}" << endl;
				}
				else
				{
					file << "		: _BaseContext(ifc, msg) {}" << endl;
				}

				file
				<< endl
				<< endl << "		~_" << method_name << "_context() {"
				<< endl << "			if (!hasReplied()) {"
				<< endl << "				send_error(::DBus::ErrorNoReply(ERROR_MSG_OBJ_DESTROYED_BEFORE_COMPLETING_REQUEST()));"
				<< endl << "			}"
				<< endl << "		}"
				<< endl;

				if ( ann_extra )
				{
					file << "		::DBus::CallInfo callInfo;" << endl;
				}

				file
				<< endl << "		void send_reply(";

				i = 0;
				for (Xml::Nodes::iterator ao = args_out.begin(); ao != args_out.end(); ++ao, ++i)
				{
					if (ao != args_out.begin()) file << ", ";

					Xml::Node &arg = **ao;
					file << "const " << signature_to_type(arg.get("type")) << "& argout" << i;
				}				

				
				file    << ") {"
				<< endl << "			if (!hasReplied()) {"
				<< endl << "				::DBus::CallMessage &call = static_cast< ::DBus::CallMessage &>(_msg);"
				<< endl << "				::DBus::ReturnMessage reply(call);"
				<< endl << "				::DBus::MessageIter wi = reply.writer();"
				<< endl;

				i = 0;
				for (Xml::Nodes::iterator ao = args_out.begin(); ao != args_out.end(); ++ao, ++i)
				{
					file << "				wi << argout" << i << ";" << endl;
				}

				file    << "				iface.object().conn().send(reply);"
				<< endl << "				setReplied(true);"
				<< endl << "			} else {"
				<< endl << "				throw ::DBus::ErrorFailed(ERROR_MSG_MULTIPLE_REPLIES());"
				<< endl << "			}"
				<< endl << "		}"
				<< endl << "	};"
				<< endl
				<< endl << "	typedef ::DBus::RefPtr<_" << method_name << "_context> " << method_name << "_ctxref;"
				<< endl;

				file
				<< endl << "public:"
				<< endl << "	// DBus method: reimplement this function in your server class to offer the desired behaviour"
				<< endl << "	virtual void " << method_name << "(";

				i = 0;
				for (Xml::Nodes::iterator ai = args_in.begin(); ai != args_in.end(); ++ai, ++i)
				{
					if (ai != args_in.begin())
						file << ", ";

					Xml::Node &arg = **ai;
					file << "const " << signature_to_type(arg.get("type")) << " &";

					string arg_name = arg.get("name");
					if (arg_name.length())
						file << arg_name;
				}

				if (!args_in.empty())
					file << ", ";

				file << method_name << "_ctxref) = 0;" << endl;

				file
				<< endl << "private:"
				<< endl
				<< endl << "	void _" << method_name << "_stub(const ::DBus::CallMessage &call) {"
				<< endl << "		::DBus::MessageIter ri = call.reader();"
				<< endl << "		" << method_name << "_ctxref ctx = new _" << method_name << "_context(*this, call);"
				<< endl;

				i = 0;
				for (Xml::Nodes::iterator ai = args_in.begin(); ai != args_in.end(); ++ai, ++i)
				{
					Xml::Node &arg = **ai;

					string arg_name = arg.get("name");

#ifdef SAVE_SERVER_ARGSIN
					if (arg_name.length())
						file << "		ri >> const_cast< " << signature_to_type(arg.get("type"))
						<< " &>(ctx->args." << arg_name << ");" << endl;
					else
						file << "		ri >> const_cast< " << signature_to_type(arg.get("type"))
						<< " &>(ctx->args.argin" << i << ");" << endl;
#else
					file << "		" << signature_to_type(arg.get("type")) << " argin" << i << "; ri >> argin" << i << ";" << endl;
#endif
				}

				file << "		" << method_name << "(";
				i = 0;
				for (Xml::Nodes::iterator ai = args_in.begin(); ai != args_in.end(); ++ai, ++i)
				{
					Xml::Node &arg = **ai;

					string arg_name = arg.get("name");

					if (ai != args_in.begin())
						file << ", ";

#ifdef SAVE_SERVER_ARGSIN
					if (arg_name.length())
						file << "ctx->args." << arg_name;
					else
						file << "ctx->args.argin" << i;
#else
					file << "argin" << i;
#endif
				}
				if ( 0 < args_in.size() )
				   file << ", ctx);" << endl;
				else
				   file << "ctx);" << endl;

				file << "	}" << endl;
			}
			else
			{
				file
				<< endl << "public:"
				<< endl << "	// DBus method: reimplement this function in your server class to offer the desired behaviour"
				<< endl << "	virtual ";

				if (args_out.size() == 0 || args_out.size() > 1)
				{
					file << "void ";
				}
				else if (args_out.size() == 1)
				{
					file << signature_to_type(args_out.front()->get("type")) << " ";
				}

				file << method_name << "(";

				i = 0;
				for (Xml::Nodes::iterator ai = args_in.begin(); ai != args_in.end(); ++ai, ++i)
				{
					Xml::Node &arg = **ai;
					file << "const " << signature_to_type(arg.get("type")) << " &";

					if (i+1 != args_in.size() || args_out.size() > 1 || ann_extra)
						file << ", ";
				}

				if (args_out.size() > 1)
				{
					unsigned int i = 0;
					for (Xml::Nodes::iterator ao = args_out.begin(); ao != args_out.end(); ++ao, ++i)
					{
						Xml::Node &arg = **ao;
						file << signature_to_type(arg.get("type")) << " &";

						string arg_name = arg.get("name");
						if (arg_name.length())
							file <<  arg_name;

						if (i+1 != args_out.size() || ann_extra)
							file << ", ";
					}
				}
				if (ann_extra)
				{
					file << "::DBus::CallInfo &info";
				}
				file << ") = 0;" << endl;

				file
				<< endl << "private:"
				<< endl
				<< endl << "	::DBus::Message _" << method_name << "_stub(const ::DBus::CallMessage &call) {"
				<< endl << "		::DBus::MessageIter ri = call.reader();"
				<< endl;

				unsigned int i = 1;
				for (Xml::Nodes::iterator ai = args_in.begin(); ai != args_in.end(); ++ai, ++i)
				{
					Xml::Node &arg = **ai;
					file << "		" << signature_to_type(arg.get("type")) << " argin" << i << ";"
					     << " ri >> argin" << i << ";" << endl;
				}

				if (args_out.size() == 0)
				{
					file << "		";
				}
				else if (args_out.size() == 1)
				{
					file << "		" << signature_to_type(args_out.front()->get("type")) << " argout1 = ";
				}
				else
				{
					unsigned int i = 1;
					for (Xml::Nodes::iterator ao = args_out.begin(); ao != args_out.end(); ++ao, ++i)
					{
						Xml::Node &arg = **ao;
						file << "		" << signature_to_type(arg.get("type")) << " argout" << i << ";" << endl;
					}
					file << "		";
				}

				if (ann_extra)
				{
					file <<    "::DBus::CallInfo info(object().conn(), call);" << endl;
				}

				file << "	" << method_name << "(";

				for (unsigned int i = 0; i < args_in.size(); ++i)
				{
					file << "argin" << i+1;

					if (i+1 != args_in.size() || args_out.size() > 1 || ann_extra)
						file << ", ";
				}

				if (args_out.size() > 1)
				for (unsigned int i = 0; i < args_out.size(); ++i)
				{
					file << "argout" << i+1;

					if (i+1 != args_out.size() || ann_extra)
						file << ", ";
				}
				if (ann_extra)
				{
					file << "info";
				}
				file << ");" << endl;

				file << "		::DBus::ReturnMessage reply(call);" << endl;

				if (args_out.size() > 0)
				{
					file << "		::DBus::MessageIter wi = reply.writer();" << endl;

					for (unsigned int i = 0; i < args_out.size(); ++i)
					{
						file << "		wi << argout" << i+1 << ";" << endl;
					}
				}

				file << "		return reply;" << endl
				     << "	}" << endl;
			}
		}
		file << "};" << endl;

		file << endl;
		for (unsigned int i = 0; i < nspaces; ++i)
		{
			file << "} ";
		}
		file << endl;
	}
	file << "#endif//" << cond_comp << endl;

	file.close();
}

int main(int argc, char ** argv)
{
	if (argc < 2)
	{
		usage(argv[0]);
	}

	bool proxy_mode, adaptor_mode;
	char *proxy, *adaptor;

	proxy_mode = false;
	proxy = 0;

	adaptor_mode = false;
	adaptor = 0;

	for (int a = 1; a < argc; ++a)
	{
		if (!std::strncmp(argv[a], "--proxy=", 8))
		{
			proxy_mode = true;
			proxy = argv[a] +8;
		}
		else
		if (!std::strncmp(argv[a], "--adaptor=", 10))
		{
			adaptor_mode = true;
			adaptor = argv[a] +10;
		}
	}

	if (!proxy_mode && !adaptor_mode) usage(argv[0]);

	ifstream xmlfile(argv[1]);

	if (xmlfile.bad())
	{
		cerr << "unable to open file " << argv[1] << endl;
		return -1;
	}

	Xml::Document doc;

	try
	{
		xmlfile >> doc;
		//cout << doc.to_xml();
	}
	catch(Xml::Error &e)
	{
		cerr << "error parsing " << argv[1] << ": " << e.what() << endl;
		return -1;
	}

	if (!doc.root)
	{
		cerr << "empty document" << endl;
		return -1;
	}

	if (proxy_mode)   generate_proxy(doc, proxy);
	if (adaptor_mode) generate_adaptor(doc, adaptor);

	return 0;
}
